# Kado Library List


## Kado Library List

This is an exhaustive list of all the JavaScript libraries provided with Kado.
Each library has a link to its documentation as well as a short description of
what is provided by the library.

* [Application](../Application.md) - Create a new application containing
  most Kado features.
* [Assert](../Assert.md) - Make assertions on input or tests.
* [Asset](../Asset.md) - Store, filter, and query static application
  files.
* [ChildProcess](../ChildProcess.md) - Child process library adding
  convenience and functionality to the core child_process functions.
* [Cluster](../Cluster.md) - Cluster library for constructing and
  operating process clusters.
* [Command](../Command.md) - Build CLI applications with ease.
* [CommandServer](../CommandServer.md) - Execute CLI applications like a
  web server.
* [Connect](../Connect.md) - Framework for housing external resource
  connections.
* [ConnectEngine](../ConnectEngine.md) - Interface for creating an engine
  to be used with a Connect system.
* [Cron](../Cron.md) - Execute functions on a schedule similar to UNIX
  cron jobs.
* [Database](../Database.md) - Connect system made for Databases.
* [Email](../Email.md) - Connect system made for Email.
* [ETag](../ETag.md) - Class for determining ETag header.
* [Event](../Event.md) - Create, track and handle application events with
  log levels.
* [FileSystem](../FileSystem.md) - Consistent API for use with File
  System methods.
* [Format](../Format.md) - Commonly used String, Number, and Date format
  methods.
* [GetOpt](../GetOpt.md) - Parse command line string input into an
  object.
* [History](../History.md) - Track user navigation history throughout
  a session.
* [HyperText](../HyperText.md) - Connect system made for HTTP servers.
* [Language](../Language.md) - Internationalization helpers including
  loading, parsing, and displaying languages.
* [Library](../Library.md) - Dynamic library loader.
* [Lifecycle](../Lifecycle.md) - Start and stop systems with events.
* [Log](../Log.md) - Connect system made for Logs.
* [Mapper](../Mapper.md) - ECMA Map functionality on Objects.
* [Message](../Message.md) - Create, track and handle messages from
  various inputs and outputs.
* [Mime](../Mime.md) - Class for determining file types.
* [Model](../Model.md) - Super class for building new data models used
  for interacting with data sets produced by data queries.
* [Module](../Module.md) - Super class for creating Kado modules.
* [Mustache](../Mustache.md) - Provides a logic-less templating system
  for use in providing any kind of text rendering.
* [Navigation](../Navigation.md) - Create and manage application menus.
* [Parser](../Parser.md) - Parse input strings to variables such as
  objects.
* [PathExp](../PathExp.md) - Use path notation to validate routes on
  URIs.
* [Permission](../Permission.md) - Create and test permission sets to
  allow fine grained user control.
* [Profiler](../Profiler.md) - Track application resource usage and
  timing.
* [PromiseMore](../PromiseMore.md) - Additional promise control patterns that
  expand the core JavaScript functionality.
* [Query](../Query.md) - Super class for constructing query builders that
  are customized for a specific query language.
* [QueryCache](../QueryCache.md) - Query cache system for databases.
* [Router](../Router.md) - Store and process application route points.
* [Schema](../Schema.md) - Super class for constructing schema builders
  that are customized for a specific schema language.
* [Search](../Search.md) - Connect system for made for search.
* [Session](../Session.md) - Session system for storing data against
  users.
* [TestRunner](../TestRunner.md) - Define and run Test Suites and Tests.
* [Util](../Util.md) - Misfit useful functions.
* [Validate](../Validate.md) - Validate input.
* [View](../View.md) - Connect system made for rendering.
